// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Layers.pas' rev: 4.00

#ifndef LayersHPP
#define LayersHPP

#pragma delphiheader begin
#pragma option push -w-
#include <Menus.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include "Channels.hpp"	// Pascal unit
#include <ExtCtrls.hpp>	// Pascal unit
#include <StdCtrls.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Layers
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TTextFX { tfxNone, tfxShadow, tfxEmboss };
#pragma option pop

class DELPHICLASS TLayer;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TLayer : public Controls::TCustomControl 
{
	typedef Controls::TCustomControl inherited;
	
private:
	Channels::TRGBChannel* FRGBChannel;
	int FCacheUpdate;
	TTextFX FCaptionFX;
	Channels::TAligns FCaptionAlign;
	int FOuter;
	Windows::TRect FOffsets;
	Channels::TChannel* FMask;
	Channels::TAligns FMaskAlign;
	Classes::TNotifyEvent FOnMouseEnter;
	Classes::TNotifyEvent FOnMouseLeave;
	void __fastcall SetCaptionFX(TTextFX AFX);
	void __fastcall SetCaptionAlign(Channels::TTextAlign AAlign);
	void __fastcall SetOffset(int AIndex, int AOffset);
	int __fastcall GetOffset(int AIndex);
	void __fastcall SetMaskAlign(Channels::TChannelAlign AAlign);
	void __fastcall SetOuter(int AOuter);
	void __fastcall PaintCache(const Graphics::TCanvas* ACanvas, const Windows::TRect &AClip);
	void __fastcall PaintGround(const Graphics::TCanvas* ACanvas, const Windows::TRect &AClip);
	void __fastcall PaintClient(const Graphics::TCanvas* ACanvas, const Windows::TRect &AClip);
	void __fastcall PaintToRect(const Graphics::TCanvas* ACanvas, const Windows::TRect &AClip, const Windows::TPoint 
		&AOrigin, bool Children);
	void __fastcall UpdateCaches(void);
	void __fastcall MaskChanged(System::TObject* Sender);
	void __fastcall SetMask(Channels::TChannel* AMask);
	
protected:
	virtual bool __fastcall PreClip(Windows::TRect &AClient);
	virtual bool __fastcall PostClip(Windows::TRect &AClient);
	virtual void __fastcall PrePaint(const Graphics::TCanvas* ACanvas, const Windows::TRect &AClip, Windows::TRect 
		&AClient);
	virtual void __fastcall PostPaint(const Graphics::TCanvas* ACanvas, const Windows::TRect &AClip, Windows::TRect 
		&AClient);
	bool __fastcall NeedParent(void);
	virtual bool __fastcall NeedCache(void);
	virtual void __fastcall Paint(void);
	HIDESBASE MESSAGE void __fastcall WMNCHitTest(Messages::TWMNCHitTest &Msg);
	HIDESBASE MESSAGE void __fastcall WMEraseBkgnd(Messages::TWMEraseBkgnd &Msg);
	HIDESBASE MESSAGE void __fastcall WMWindowPosChanging(Messages::TWMWindowPosMsg &Msg);
	HIDESBASE MESSAGE void __fastcall CMVisibleChanged(Messages::TMessage &Msg);
	HIDESBASE MESSAGE void __fastcall CMColorChanged(Messages::TMessage &Msg);
	MESSAGE void __fastcall CMTextChanged(Messages::TMessage &Msg);
	HIDESBASE MESSAGE void __fastcall CMFontChanged(Messages::TMessage &Msg);
	HIDESBASE MESSAGE void __fastcall CMMouseEnter(Messages::TMessage &Msg);
	HIDESBASE MESSAGE void __fastcall CMMouseLeave(Messages::TMessage &Msg);
	virtual void __fastcall AlignControls(Controls::TControl* AControl, Windows::TRect &Rect);
	Windows::TRect __fastcall AdjustRectIn(const Windows::TRect &ARect);
	Windows::TRect __fastcall AdjustRectOut(const Windows::TRect &ARect);
	
public:
	__property Channels::TRGBChannel* RGBChannel = {read=FRGBChannel};
	void __fastcall UpdateCache(void);
	void __fastcall InvalidateAfter(Controls::TWinControl* AParent, Controls::TWinControl* AStopper, Windows::PRect 
		APRect);
	void __fastcall NotifyOverlays(bool ASelfRepaint);
	void __fastcall InvalidateArea(Windows::PRect APRect);
	__fastcall virtual TLayer(Classes::TComponent* AOwner);
	__fastcall virtual ~TLayer(void);
	
__published:
	__property Caption ;
	__property TTextFX CaptionFX = {read=FCaptionFX, write=SetCaptionFX, default=0};
	__property Channels::TTextAlign CaptionAlign = {read=FCaptionAlign, write=SetCaptionAlign, default=5
		};
	__property int OffsetLeft = {read=GetOffset, write=SetOffset, index=0, default=0};
	__property int OffsetTop = {read=GetOffset, write=SetOffset, index=1, default=0};
	__property int OffsetRight = {read=GetOffset, write=SetOffset, index=2, default=0};
	__property int OffsetBottom = {read=GetOffset, write=SetOffset, index=3, default=0};
	__property Channels::TChannel* Mask = {read=FMask, write=SetMask};
	__property Channels::TChannelAlign MaskAlign = {read=FMaskAlign, write=SetMaskAlign, default=0};
	__property int Outer = {read=FOuter, write=SetOuter, default=0};
	__property Align ;
	__property Visible ;
	__property Enabled ;
	__property Color ;
	__property ParentColor ;
	__property Font ;
	__property ParentFont ;
	__property Hint ;
	__property ShowHint ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property Classes::TNotifyEvent OnMouseLeave = {read=FOnMouseLeave, write=FOnMouseLeave};
	__property Classes::TNotifyEvent OnMouseEnter = {read=FOnMouseEnter, write=FOnMouseEnter};
	__property OnClick ;
	__property OnDblClick ;
	__property OnMouseDown ;
	__property OnMouseUp ;
	__property OnMouseMove ;
	__property OnExit ;
	__property OnEnter ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TLayer(HWND ParentWindow) : Controls::TCustomControl(
		ParentWindow) { }
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TImageLayer;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TImageLayer : public TLayer 
{
	typedef TLayer inherited;
	
private:
	Windows::TPoint FImagePos;
	Windows::TPoint FOldMouse;
	Graphics::TPicture* FImage;
	Channels::TAligns FImageAlign;
	bool FImageClient;
	bool FAutoSize;
	bool FAutoScroll;
	void __fastcall SetImage(Graphics::TPicture* AImage);
	void __fastcall SetImageAlign(Channels::TImageAlign AAlign);
	void __fastcall SetImageClient(bool AClient);
	HIDESBASE void __fastcall SetAutoSize(bool AAutoSize);
	void __fastcall ImageChanged(System::TObject* Sender);
	bool __fastcall GetCanScroll(void);
	
protected:
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, 
		int Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	virtual void __fastcall PrePaint(const Graphics::TCanvas* ACanvas, const Windows::TRect &AClip, Windows::TRect 
		&AClient);
	virtual void __fastcall AlignControls(Controls::TControl* AControl, Windows::TRect &Rect);
	virtual bool __fastcall PostClip(Windows::TRect &AClient);
	HIDESBASE MESSAGE void __fastcall WMNCHitTest(Messages::TWMNCHitTest &Msg);
	
public:
	__fastcall virtual TImageLayer(Classes::TComponent* AOwner);
	__fastcall virtual ~TImageLayer(void);
	__property bool CanScroll = {read=GetCanScroll, nodefault};
	
__published:
	__property Graphics::TPicture* Image = {read=FImage, write=SetImage};
	__property Channels::TImageAlign ImageAlign = {read=FImageAlign, write=SetImageAlign, default=5};
	__property bool ImageClient = {read=FImageClient, write=SetImageClient, default=0};
	__property bool AutoSize = {read=FAutoSize, write=SetAutoSize, default=0};
	__property bool AutoScroll = {read=FAutoScroll, write=FAutoScroll, default=0};
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TImageLayer(HWND ParentWindow) : TLayer(ParentWindow
		) { }
	#pragma option pop
	
};

#pragma pack(pop)

class DELPHICLASS TButtonLayer;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TButtonLayer : public TLayer 
{
	typedef TLayer inherited;
	
private:
	Channels::TChannel* FGlyph;
	Byte FGlyphPower;
	Byte FGlyphPowers[2];
	void __fastcall SetPower(Byte APower);
	void __fastcall SetGlyphPower(int AIndex, Byte APower);
	void __fastcall SetGlyph(Channels::TChannel* AGlyph);
	void __fastcall GlyphChanged(System::TObject* Sender);
	
protected:
	HIDESBASE MESSAGE void __fastcall CMMouseEnter(Messages::TMessage &Msg);
	HIDESBASE MESSAGE void __fastcall CMMouseLeave(Messages::TMessage &Msg);
	HIDESBASE MESSAGE void __fastcall WMNCHitTest(Messages::TWMNCHitTest &Msg);
	virtual void __fastcall PrePaint(const Graphics::TCanvas* ACanvas, const Windows::TRect &AClip, Windows::TRect 
		&AClient);
	virtual void __fastcall PostPaint(const Graphics::TCanvas* ACanvas, const Windows::TRect &AClip, Windows::TRect 
		&AClient);
	virtual bool __fastcall NeedCache(void);
	
public:
	__fastcall virtual TButtonLayer(Classes::TComponent* AOwner);
	__fastcall virtual ~TButtonLayer(void);
	
__published:
	__property Channels::TChannel* Glyph = {read=FGlyph, write=SetGlyph};
	__property Byte GlyphActive = {read=FGlyphPowers[557], write=SetGlyphPower, index=0, default=255};
	__property Byte GlyphInactive = {read=FGlyphPowers[558], write=SetGlyphPower, index=1, default=64};
		
	__property MaskAlign ;
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TButtonLayer(HWND ParentWindow) : TLayer(ParentWindow
		) { }
	#pragma option pop
	
};

#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------
static const Shortint crHandPointer = 0x1;
extern PACKAGE bool __fastcall CheckMode(void);

}	/* namespace Layers */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Layers;
#endif
#pragma option pop	// -w-

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Layers
